/**
 * Copyright (c) 2021 Dominic Msters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "game.h"

typedef struct {
  engine_t *engine;
} dawngame_t;

game_t * gameInit(char *gameName) {
  // Create the game
  dawngame_t *dawn = malloc(sizeof(dawngame_t));
  if(dawn == NULL) return NULL;

  // Load the game engine
  dawn->engine = engineInit("Dawn Game");
  if(dawn->engine == NULL) {
    free(dawn);
    return NULL;
  }

  // Pass to the main game to handle.
  return (game_t *)dawn;
}

void gameStart(game_t *game) {
  dawngame_t *dawn = (dawngame_t *)game;
  engineStart(dawn->engine);
}

void gameDispose(game_t *game) {
  dawngame_t *dawn = (dawngame_t *)game;
  engineDispose(dawn->engine);
  free(dawn);
}